generic

  type Listen_Index is range <>;

  type Listen_Element is private;

package Liste is

  procedure Lies    (Index: in Listen_Index; Element:    out Listen_Element);
  procedure Schreib (Index: in Listen_Index; Element: in     Listen_Element);

end Liste;
package body Liste is

  X: Listen_Element;

  procedure Lies (Index: in Listen_Index; Element: out Listen_Element)is
  begin
    Element := X;
  end Lies;

  procedure Schreib (Index: in Listen_Index; Element: in Listen_Element)is
  begin
    X := Element;
  end;

end Liste;
-----------------------------------------------------------------------
with Liste;

package Suendenregister is

  subtype Menschensuende is integer;
  subtype Maennersuende  is integer;
  subtype Frauensuende   is integer;

  Aleph_0: constant := 1;  -- irdische Annaeherung and himmlische Geduld
  
  Reif_fuer_die_Hoelle: constant := Aleph_0;

  type Nummer is range 1 .. Reif_fuer_die_Hoelle;

  type Mensch is (Adam, Eva);

  type Eintrag (Wessen: Mensch := Mensch'First) is record
    Allgemeine_Suende: Menschensuende;
    case Wessen is
      when Adam => Adams_Suende: Maennersuende;
      when Eva  => Evas_Suende : Frauensuende;
    end case;
  end record;

  subtype Adams_Eintrag is Eintrag (Adam);
  subtype Evas_Eintrag  is Eintrag (Eva);

  package Adams_Suendenregister is new Liste (Listen_Index   => Nummer,
                                              Listen_Element => Adams_Eintrag);
  package Evas_Suendenregister  is new Liste (Listen_Index   => Nummer,
                                              Listen_Element => Evas_Eintrag);

end Suendenregister;
-----------------------------------------------------------------------
with Ada.Text_IO;

with Suendenregister;
use  Suendenregister;

procedure Paradies is

  procedure Lies_Suende (Wessen: in     Mensch;
                         Welche: in     Nummer;
                         Suende:    out Eintrag) is
  begin
    case Wessen is
      when Adam => Adams_Suendenregister.Lies (Welche, Suende);
      when Eva  => Evas_Suendenregister .Lies (Welche, Suende);
    end case;
  end Lies_Suende;

  Suende: Eintrag;  -- keine Einschrnkung

  -- Die einzige Einschrnkung im Paradies:
  vom_Baume_der_Erkenntnis_gegessen: exception renames Constraint_Error;
  
begin

  Ada.Text_IO.Put_Line ("Adam");  Lies_Suende (Adam, 1, Suende);
  Ada.Text_IO.Put_Line ("Eva" );  Lies_Suende (Eva , 1, Suende);

exception
  when vom_Baume_der_Erkenntnis_gegessen =>
    Ada.Text_IO.Put_Line ("Ab_in_die_Hoelle");

end Paradies;
